# Introduction

Guetzli is a JPEG encoder that aims for excellent compression density at high
visual quality. Guetzli-generated images are typically 20-30% smaller than
images of equivalent quality generated by libjpeg. Guetzli generates only
sequential (nonprogressive) JPEGs due to faster decompression speeds they offer.

# Building

1.  Get a copy of the source code, either by cloning this repository, or by
    downloading an
    [archive](https://github.com/google/guetzli/archive/master.zip) and
    unpacking it.
2.  Install [Bazel](https://www.bazel.io) by following its [installation
    instructions](https://www.bazel.io/versions/master/docs/install.html).
3.  Run `bazel build -c opt :guetzli` in the directory this README file is in.

# Using

To try out Guetzli you need to [build](#building) or
[download](https://github.com/google/guetzli/releases) the Guetzli binary. The
binary reads a PNG or JPEG image and creates an optimized JPEG image:

```bash
bazel-bin/guetzli original.png output.jpg
bazel-bin/guetzli original.jpg output.jpg
```

You can pass a `--quality Q` parameter to set quality in units equivalent to
libjpeg quality. You can also pass a `--verbose` flag to see a trace of encoding
attempts made.

Please note that JPEG images do not support alpha channel (transparency). If
the input is a PNG with an alpha channel, it will be overlaid on black
background before encoding.
